CfnKey L1 construct
Creates an AWS Payment Cryptography key, a logical representation of a cryptographic key, that is unique in your account and AWS Region .
You use keys for cryptographic functions such as encryption and decryption.
In addition to the key material used in cryptographic operations, an AWS Payment Cryptography key includes metadata such as the key ARN, key usage, key origin, creation date, description, and key state.
When you create a key, you specify both immutable and mutable data about the key. The immutable data contains key attributes that define the scope and cryptographic operations that you can perform using the key, for example key class (example: SYMMETRIC_KEY ), key algorithm (example: TDES_2KEY ), key usage (example: TR31_P0_PIN_ENCRYPTION_KEY ) and key modes of use (example: Encrypt ). AWS Payment Cryptography binds key attributes to keys using key blocks when you store or export them. AWS Payment Cryptography stores the key contents wrapped and never stores or transmits them in the clear.
For information about valid combinations of key attributes, see Understanding key attributes in the AWS Payment Cryptography User Guide . The mutable data contained within a key includes usage timestamp and key deletion timestamp and can be modified after creation.
You can use the CreateKey operation to generate an ECC (Elliptic Curve Cryptography) key pair used for establishing an ECDH (Elliptic Curve Diffie-Hellman) key agreement between two parties. In the ECDH key agreement process, both parties generate their own ECC key pair with key usage K3 and exchange the public keys. Each party then use their private key, the received public key from the other party, and the key derivation parameters including key derivation function, hash algorithm, derivation data, and key algorithm to derive a shared key.
To maintain the single-use principle of cryptographic keys in payments, ECDH derived keys should not be used for multiple purposes, such as a TR31_P0_PIN_ENCRYPTION_KEY and TR31_K1_KEY_BLOCK_PROTECTION_KEY . When creating ECC key pairs in AWS Payment Cryptography you can optionally set the DeriveKeyUsage parameter, which defines the key usage bound to the symmetric key that will be derived using the ECC key pair.
Cross-account use : This operation can't be used across different AWS accounts.
Related operations:
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_paymentcryptography as paymentcryptography } from 'aws-cdk-lib';
const cfnKey = new paymentcryptography.CfnKey(this, 'MyCfnKey', {
exportable: false,
keyAttributes: {
keyAlgorithm: 'keyAlgorithm',
keyClass: 'keyClass',
keyModesOfUse: {
decrypt: false,
deriveKey: false,
encrypt: false,
generate: false,
noRestrictions: false,
sign: false,
unwrap: false,
verify: false,
wrap: false,
},
keyUsage: 'keyUsage',
},
// the properties below are optional
deriveKeyUsage: 'deriveKeyUsage',
enabled: false,
keyCheckValueAlgorithm: 'keyCheckValueAlgorithm',
policy: 'policy',
replicationRegions: ['replicationRegions'],
tags: [{
key: 'key',
value: 'value',
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_paymentcryptography as paymentcryptography
cfn_key = paymentcryptography.CfnKey(self, "MyCfnKey",
exportable=False,
key_attributes=paymentcryptography.CfnKey.KeyAttributesProperty(
key_algorithm="keyAlgorithm",
key_class="keyClass",
key_modes_of_use=paymentcryptography.CfnKey.KeyModesOfUseProperty(
decrypt=False,
derive_key=False,
encrypt=False,
generate=False,
no_restrictions=False,
sign=False,
unwrap=False,
verify=False,
wrap=False
),
key_usage="keyUsage"
),
# the properties below are optional
derive_key_usage="deriveKeyUsage",
enabled=False,
key_check_value_algorithm="keyCheckValueAlgorithm",
policy="policy",
replication_regions=["replicationRegions"],
tags=[CfnTag(
key="key",
value="value"
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.paymentcryptography.*;
CfnKey cfnKey = CfnKey.Builder.create(this, "MyCfnKey")
.exportable(false)
.keyAttributes(KeyAttributesProperty.builder()
.keyAlgorithm("keyAlgorithm")
.keyClass("keyClass")
.keyModesOfUse(KeyModesOfUseProperty.builder()
.decrypt(false)
.deriveKey(false)
.encrypt(false)
.generate(false)
.noRestrictions(false)
.sign(false)
.unwrap(false)
.verify(false)
.wrap(false)
.build())
.keyUsage("keyUsage")
.build())
// the properties below are optional
.deriveKeyUsage("deriveKeyUsage")
.enabled(false)
.keyCheckValueAlgorithm("keyCheckValueAlgorithm")
.policy("policy")
.replicationRegions(List.of("replicationRegions"))
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.PaymentCryptography;
var cfnKey = new CfnKey(this, "MyCfnKey", new CfnKeyProps {
Exportable = false,
KeyAttributes = new KeyAttributesProperty {
KeyAlgorithm = "keyAlgorithm",
KeyClass = "keyClass",
KeyModesOfUse = new KeyModesOfUseProperty {
Decrypt = false,
DeriveKey = false,
Encrypt = false,
Generate = false,
NoRestrictions = false,
Sign = false,
Unwrap = false,
Verify = false,
Wrap = false
},
KeyUsage = "keyUsage"
},
// the properties below are optional
DeriveKeyUsage = "deriveKeyUsage",
Enabled = false,
KeyCheckValueAlgorithm = "keyCheckValueAlgorithm",
Policy = "policy",
ReplicationRegions = new [] { "replicationRegions" },
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnKey := awscdk.Aws_paymentcryptography.NewCfnKey(this, jsii.String("MyCfnKey"), &CfnKeyProps{
Exportable: jsii.Boolean(false),
KeyAttributes: &KeyAttributesProperty{
KeyAlgorithm: jsii.String("keyAlgorithm"),
KeyClass: jsii.String("keyClass"),
KeyModesOfUse: &KeyModesOfUseProperty{
Decrypt: jsii.Boolean(false),
DeriveKey: jsii.Boolean(false),
Encrypt: jsii.Boolean(false),
Generate: jsii.Boolean(false),
NoRestrictions: jsii.Boolean(false),
Sign: jsii.Boolean(false),
Unwrap: jsii.Boolean(false),
Verify: jsii.Boolean(false),
Wrap: jsii.Boolean(false),
},
KeyUsage: jsii.String("keyUsage"),
},
// the properties below are optional
DeriveKeyUsage: jsii.String("deriveKeyUsage"),
Enabled: jsii.Boolean(false),
KeyCheckValueAlgorithm: jsii.String("keyCheckValueAlgorithm"),
Policy: jsii.String("policy"),
ReplicationRegions: []*string{
jsii.String("replicationRegions"),
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
})
Initializer
new CfnKey(scope: Construct, id: string, props: CfnKeyProps)
CfnKey(scope: Construct, id: str, props: CfnKeyProps)
new CfnKey(Construct scope, String id, CfnKeyProps props)
new CfnKey(Construct scope, string id, CfnKeyProps props)
NewCfnKey(Scope Construct, Id *string, Props CfnKeyProps)
Construct Props
deriveKeyUsageoptionalstringderive_key_usageoptionalstrderiveKeyUsageoptionalStringDeriveKeyUsageoptionalstringDeriveKeyUsageoptional*string#enabledoptionalboolean | IResolvableenabledoptionaltyping.Union[bool, IResolvable]enabledoptionalBooleanEnabledoptionalboolEnabledoptionalinterface{}#exportableboolean | IResolvableexportabletyping.Union[bool, IResolvable]exportableBooleanExportableboolExportableinterface{}required#This data is immutable after the key is created.
keyAttributesIResolvable | CfnKey.KeyAttributesPropertykey_attributestyping.Union[IResolvable, KeyAttributesProperty]keyAttributesIResolvableKeyAttributesIResolvableKeyAttributesinterface{}required#This data is immutable after the key is created.
keyCheckValueAlgorithmoptionalstringkey_check_value_algorithmoptionalstrkeyCheckValueAlgorithmoptionalStringKeyCheckValueAlgorithmoptionalstringKeyCheckValueAlgorithmoptional*string#notes
It is used to validate the key integrity.
For TDES keys, the KCV is computed by encrypting 8 bytes, each with value of zero, with the key to be checked and retaining the 3 highest order bytes of the encrypted result. For AES keys, the KCV is computed using a CMAC algorithm where the input data is 16 bytes of zero and retaining the 3 highest order bytes of the encrypted result.
replicationRegionsoptionalstring[]replication_regionsoptionaltyping.List[str]replicationRegionsoptionalList<String>ReplicationRegionsoptionalstring[]ReplicationRegionsoptional*[]*string#The key will no longer be available for cryptographic operations in these regions after removal. Ensure no active operations depend on the key in these regions before removal.
Properties
attrKeyIdentifierstringattr_key_identifierstrattrKeyIdentifierStringAttrKeyIdentifierstringAttrKeyIdentifier*stringrequired#attrKeyOriginstringattr_key_originstrattrKeyOriginStringAttrKeyOriginstringAttrKeyOrigin*stringrequired#For keys created within AWS Payment Cryptography, the value is AWS_PAYMENT_CRYPTOGRAPHY . For keys imported into AWS Payment Cryptography, the value is EXTERNAL .
attrReplicationStatusIResolvableattr_replication_statusIResolvableattrReplicationStatusIResolvableAttrReplicationStatusIResolvableAttrReplicationStatusIResolvablerequired#cdkTagManagerTagManagercdk_tag_managerTagManagercdkTagManagerTagManagerCdkTagManagerTagManagerCdkTagManagerTagManagerrequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#deriveKeyUsagemay be undefinedstringderive_key_usagemay be undefinedstrderiveKeyUsagemay be undefinedStringDeriveKeyUsagemay be undefinedstringDeriveKeyUsagemay be undefined*string#enabledmay be undefinedboolean | IResolvableenabledmay be undefinedtyping.Union[bool, IResolvable]enabledmay be undefinedBooleanEnabledmay be undefinedboolEnabledmay be undefinedinterface{}#exportableboolean | IResolvableexportabletyping.Union[bool, IResolvable]exportableBooleanExportableboolExportableinterface{}required#keyAttributesIResolvable | CfnKey.KeyAttributesPropertykey_attributestyping.Union[IResolvable, KeyAttributesProperty]keyAttributesIResolvableKeyAttributesIResolvableKeyAttributesinterface{}required#keyCheckValueAlgorithmmay be undefinedstringkey_check_value_algorithmmay be undefinedstrkeyCheckValueAlgorithmmay be undefinedStringKeyCheckValueAlgorithmmay be undefinedstringKeyCheckValueAlgorithmmay be undefined*string#keyRefKeyReferencekey_refKeyReferencekeyRefKeyReferenceKeyRefKeyReferenceKeyRefKeyReferencerequired#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
policymay be undefinedstringpolicymay be undefinedstrpolicymay be undefinedStringPolicymay be undefinedstringPolicymay be undefined*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
replicationRegionsmay be undefinedstring[]replication_regionsmay be undefinedtyping.List[str]replicationRegionsmay be undefinedList<String>ReplicationRegionsmay be undefinedstring[]ReplicationRegionsmay be undefined*[]*string#CfnElements must be defined within a stack scope (directly or indirectly).
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnKey(x: any): boolean@staticmethod def is_cfn_key(x: Any) -> boolpublic static Boolean isCfnKey(Object x)public static bool IsCfnKey(object x)func IsCfnKey(X interface{}) *boolstatic#isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.